package procedures.orderings;

import types.procedures.ICompare;
import structures.map.Entry;

// Compares entries based on a key comparison.
public class EntryOrder implements ICompare {
	
	public ICompare keyOrder;
	
	public EntryOrder( ICompare keyOrder ) {
		this.keyOrder = keyOrder;
	}

	public int compare(Object o1, Object o2) {
		Entry e1 = (Entry)o1;
		Entry e2 = (Entry)o2;
		return keyOrder.compare(e1.key, e2.key);
	}

}
