package procedures.predicates;

import types.procedures.ISelect;
import types.structures.ITree;

// Tells whether a binary tree is balanced.
public class AVLInvariant implements ISelect {

	public boolean select(Object input) {
		ITree tree = (ITree)input;
		
		if ( tree.isLeaf() ) {
			return true;
		} else {
			int h1 = tree.getLeft().getHeight();
			int h2 = tree.getRight().getHeight();
			
			return Math.abs(h1 - h2) <= 1;
		}
	}

}
