package structures.map;

import types.structures.ISame;

// Represents a pair of values
public class Entry implements ISame {

	public ISame key;
	public Object value;
	
	public Entry( ISame key, Object value ) {
		this.key = key;
		this.value = value;
	}

	// Tells whether this is the same as that.
	public boolean same( ISame that ) {
		if ( that instanceof Entry ) {
			Entry e2 = (Entry)that;
			
			return
				(this.key).same(e2.key) &&
				((ISame)this.value).same((ISame)e2.value);
		} else {
			return false;
		}
	}
	
	// Produces a string for displaying this.
	public String toString() {
		return "[" + key.toString() + " => " + value.toString() + "]";
	}
	
}
